module CanField
  module CanCan
    module AbilityAdditions
      # see README.md
      def canf(actions, target, fields, opt_hash = nil, &block)
        unless actions.is_a? Array
          actions = [actions]
        end

        unless fields.is_a? Array
          fields = [fields]
        end

        actions.each do |action|
          can action.to_sym, target, opt_hash, &block
        end

        actions.product(fields).each do |x|
          action, field = x
          can "_cf_#{action}_fl_#{field}".to_sym, target, opt_hash, &block
        end
      end

      # for internal use
      def abilities_for_subject(subject)
        @rules.select{|a| a.relevant_for_subject? subject}.map(&:actions).flatten.uniq
      end
    end
  end
end

if defined? CanCan::Ability
  CanCan::Ability.class_eval do
    include CanField::CanCan::AbilityAdditions
  end
end
